

MouseResponseFrb proto :dword,dwInd:dword
Music proto :dword
PlaySoundFrb proto
PlaySoundFrb2 proto hWnd:dword,lptz:dword,nStart:dword,nCount:dword

DrawTextBoxFrb proto dwInd:dword
fScrollBar proto lps:dword,x:dword,y:dword,l:dword,t:dword,index:dword,nMaxIndex:dword,col:dword


MainInit		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
MainLoop		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
TopXY			PROTO	:DWORD,:DWORD
DrawScene		PROTO
GlInit			PROTO	:DWORD,:DWORD
ResizeObject		PROTO	:DWORD,:DWORD
CreateSphere		PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
SetLightSource		PROTO	:DWORD,:DWORD,:DWORD
RotateObject		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
DeleteSpheres		PROTO

ControlFrb proto :dword

CreateRect proto :dword

InitControlFrb proto hWnd:HWND

PlaceHandleFrb proto  dwHandle:dword
TakeHandleFrb proto  dwPos:dword
ResetHandleFrb proto 
TakeHandleCountFrb proto 
CreateButtonFrb  proto  x:dword,y:dword,dwWidth:dword,dwHeigth:dword,dwColor:dword,lptz:dword
DestroyButtonFrb proto  dwInd:dword
CreateTextBoxFrb proto  x:dword,y:dword,dwWidth:dword,dwHeigth:dword,dwColor:dword,lpsf:dword
DrawTextBoxFrb proto dwInd:dword
DrawButtonFrb proto   dwInd:dword
MouseResponseFrb proto   hWnd:dword,dwInd:dword
ShowListFrb proto dwIndex:dword,x:dword,y:dword
ButtonListDrawFrb proto  dwInd:dword
ButtonListTextDrawFrb proto  dwInd:dword
DrawFrameFrb proto  hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
InputMouseFrb proto lParam:dword
SetFontFrb proto hnd:dword
fScrollBar proto lps:dword,x:dword,y:dword,l:dword,t:dword,index:dword,nMaxIndex:dword,col:dword
MessageInterceptFrb proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

ControlFrb2 proto hWnd:dword
Show_text_textbox proto :dword


PFD_MAIN_PLANE		equ	0
PFD_TYPE_COLORINDEX	equ	1
PFD_TYPE_RGBA		equ	0
PFD_DOUBLEBUFFER	equ	1
PFD_DRAW_TO_WINDOW	equ	4
PFD_SUPPORT_OPENGL	equ	020h

; --------------- Data Section
			.data

PixFrm			PIXELFORMATDESCRIPTOR <>

MainHDC			dd	0
OpenDC			dd	0

; Some values
Value0Flt		dd	0.0
Value1Flt		dd	1.0
Value1Dbl		dq	1.0
Value45Dbl		dq	5.0
Value3Dbl		dq	3.0
Value7Dbl		dq	7.0

; Light position
LightSourcePosition	dd	-2.0,-2.0,-4.0,0.0
LightSource2Position	dd	2.0,2.0,4.0,0.0
LightSource3Position	dd	-2.0,2.0,4.0,0.0
LightAmbient		dd	0.2,0.0,0.0,1.0
Light2Ambient		dd	0.0,0.2,0.0,1.0
Light3Ambient		dd	0.0,0.0,0.2,1.0
LightDiffuse		dd	1.0,1.0,1.0,1.0
LightSpecular		dd	1.0,1.0,1.0,1.0
SpotCut			dd	-1.0
SpotExp			dd	0.0
SpotDir			dd	-1.0,-1.0,-1.0
LightConstAtt		dd	1.0
LightLinAtt		dd	1.0
LightQuadAtt		dd	1.0

; --- Sphere 1
; Angles
Sphere1AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere1AnglesSpeedFlt	dd	-0.0,-0.0,-0.0
; Objects datas
Sphere1Color		dd	0.6,0.4,0.2,0.0
Sphere1Radius		dq	0.11
sphere1Parts		dd	32
Sphere1Position		dd	0.0,0.0,-5.000
GlSphere1		dd	0

; --- Sphere 2
; Angles
Sphere2AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere2AnglesSpeedFlt	dd	0,0.0,0.0
; Objects datas
Sphere2Color		dd	0.8,0.8,0.0,0.0
Sphere2Radius		dq	0.01
sphere2Parts		dd	24
Sphere2Position		dd	0.01,0.0,0.120
GlSphere2		dd	0

RectAnglesSpeedFlt	dd	0,0.0,0.0

xorg dd 0,0,0,0

SB struct
	x dword 0
	y dword 0
	w dword 0
	h dword 0
SB ends

.data?
	lpHndGUI  dword ?
	lpDataGUI dword ?
	guis fDC <?>
	mDCGUI dword ?
	bih BITMAPINFOHEADER <?>
	hBmpGUI dword ?
	m POINT <?>
	
	m_mcur dword ?
	hDC dword ?
	
	VideoFrb dword ?
	KEYFRB_UP_LP dword ?
	KEYFRB_UP_WP dword ?
	
.data
	s db 'load.wav',0
	a db 'wMap.bmp',0
	a2 db 'Farabi2.bmp',0
	
	frbsnd db 'waveaudio',0
	
	m_hlgt dword -1
	
	mo MCI_OPEN_PARMS <?>
	mp MCI_PLAY_PARMS <?>
	
.code

InitControlFrb proc hWnd:HWND
	LOCAL mDC:dword,hOld:dword 
	LOCAL r:RECT 
	LOCAL Text[1024]:dword 
	LOCAL posX,posY,clr,xc,yc,xc2,yc2,xc3,yc3,xc4,yc4,co:dword 
	LOCAL g:wBMP
	LOCAL pbm,PixFormat:dword
	LOCAL WINRect:RECT

	invoke GlobalAlloc,LMEM_DISCARDABLE,(1024*768*4)*2
	invoke GlobalLock,eax
	mov guis.lpBits,eax
	
	
	invoke GetDC,hWnd
 	mov hDC,eax 
	
	invoke CreateCompatibleDC,hDC
	mov mDCGUI,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,1024		;r.right
	mov guis.MaxX,eax
	mov eax,768			;r.bottom
	mov guis.MaxY,eax	
	
	mov guis.nBit,32
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDCGUI,addr bih,DIB_RGB_COLORS,addr pbm,0,0
	mov hBmpGUI,eax
		
	invoke SelectObject,mDCGUI,hBmpGUI 
	mov hOld,eax

	
	invoke SetBkMode,mDCGUI,TRANSPARENT 
	invoke SetTextColor,mDCGUI,0FF00h
	invoke ReleaseDC,hWnd,hDC
	
	
	
	invoke GlobalAlloc,GMEM_ZEROINIT,1000
	mov lpHndGUI,eax
	invoke GlobalLock,eax
	mov lpDataGUI,eax
 	
	invoke Phase1
	
	invoke GetDC,hWnd
	mov hDC,eax
				mov	ax,SIZEOF PixFrm
				mov	PixFrm.nSize,ax
				mov	PixFrm.nVersion,1
				mov	PixFrm.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
				mov	PixFrm.dwLayerMask,PFD_MAIN_PLANE
				mov	PixFrm.iPixelType,PFD_TYPE_RGBA
				mov	PixFrm.cColorBits,8
				mov	PixFrm.cDepthBits,16
				mov	PixFrm.cAccumBits,0
				mov	PixFrm.cStencilBits,0
				invoke	ChoosePixelFormat,hDC,ADDR PixFrm
				mov	PixFormat,eax
				invoke	SetPixelFormat,hDC,PixFormat,ADDR PixFrm
				or	eax,eax
				jz	NoPixelFmt
				invoke	wglCreateContext,hDC
				mov	OpenDC,eax
				invoke	wglMakeCurrent,hDC,OpenDC
				invoke	GetClientRect,hWnd,ADDR WINRect
				
				invoke GlInit,WINRect.right,WINRect.bottom
				
				ret
				NoPixelFmt:
				invoke PostQuitMessage,NULL

	
	
	ret
InitControlFrb endp

PlaceHandleFrb proc uses esi dwHandle:dword
	
	
	mov esi,lpDataGUI
	mov ecx,[esi]
	add esi,4
	
	mov eax,dwHandle
	mov [esi+ecx*4],eax
	
	sub esi,4
	inc ecx
	mov [esi],ecx
	
	ret
PlaceHandleFrb endp

TakeHandleFrb proc uses esi dwPos:dword
	
	mov esi,lpDataGUI
	mov ecx,dwPos
	add esi,4
	mov eax,[esi+ecx*4]
	
	ret
TakeHandleFrb endp

ResetHandleFrb proc uses esi
	
	mov esi,lpDataGUI
	xor eax,eax
	mov [esi],eax
	
	ret
ResetHandleFrb endp

TakeHandleCountFrb proc uses esi
	
	mov esi,lpDataGUI
	mov eax,[esi]
	
	ret
TakeHandleCountFrb endp

CreateButtonFrb  proc uses esi x:dword,y:dword,dwWidth:dword,dwHeigth:dword,dwColor:dword,lptz:dword
	LOCAL cbfp,cbfh,h:dword
	LOCAL w:warna
	LOCAL b:warna
	LOCAL tmp:dword
	
	mov esi,lpDataGUI
	mov eax,[esi]
	
	invoke TakeHandleCountFrb
	cmp eax,250
	jl @f
		xor eax,eax
		dec eax
		ret
	@@:
	
	xor edx,edx
	mov edx,dwHeigth	
	shl edx,2
	add edx,28
	
	invoke GlobalAlloc,LMEM_ZEROINIT,edx
	mov cbfh,eax
	invoke PlaceHandleFrb,eax
	invoke GlobalLock,cbfh
	mov cbfp,eax
	
	push eax
		invoke SprtPixel16,addr w,dwColor,guis.nBit
		push dwHeigth
		pop h		
	pop esi
	
	mov eax,'FRBX'
	bswap eax
	mov [esi],eax
	add esi,4
	
	mov eax,x
	mov dword ptr[esi],eax
	add esi,4

	mov eax,y
	mov dword ptr[esi],eax
	add esi,4

	mov eax,dwWidth
	mov dword ptr[esi],eax
	add esi,4

	mov eax,dwHeigth
	mov dword ptr[esi],eax
	add esi,4
	
	mov eax,lptz
	xor ecx,ecx
	cmp eax,ecx
	jz @f
		mov dword ptr[esi],eax
	@@:
	
	add esi,4
	
	invoke LineLength,lptz,300
	dec eax
	mov dword ptr[esi],eax
	
	
	add esi,4
	
	lea edi,tmp
	xor ecx,ecx
	mov [edi],ecx
	@@:
	mov ecx,[edi]
		invoke fGrad,ecx,dwHeigth,w.merah
		add eax,w.merah
		mov b.merah,eax
	mov ecx,[edi]
		invoke fGrad,ecx,dwHeigth,w.hijau
		add eax,w.hijau
		mov b.hijau,eax
	mov ecx,[edi]
		invoke fGrad,ecx,dwHeigth,w.biru
		add eax,w.biru
		mov b.biru,eax
		
		invoke CreatePixel16,b.merah,b.hijau,b.biru,32
	mov [esi],eax
	add esi,4
	
	mov ecx,[edi]
	inc ecx
	mov [edi],ecx
	
	dec h
	jnz @b
	
	
	invoke GlobalUnlock,cbfp
	
	invoke TakeHandleCountFrb
	dec eax
	
	ret
CreateButtonFrb endp

DestroyButtonFrb proc uses esi dwInd:dword
	
	invoke TakeHandleCountFrb
	mov edx,dwInd
	cmp edx,eax
	jle @f
		ret
	@@:
	
	mov esi,lpDataGUI
	add esi,4
	
	mov ecx,dwInd
	mov eax,[esi+ecx*4]
	
	invoke LocalFree,eax
		
	
		
	ret
DestroyButtonFrb endp


CreateTextBoxFrb proc uses esi x:dword,y:dword,dwWidth:dword,dwHeigth:dword,dwColor:dword,lpsf:dword
	LOCAL hndf,pntf:dword
	LOCAL tmp:dword
	; ID x y w h c s lpaddr
	
	invoke GlobalAlloc,GMEM_ZEROINIT,128
	mov hndf,eax
	invoke PlaceHandleFrb,eax
	invoke GlobalLock,eax
	mov pntf,eax
	
	
	mov esi,pntf
	mov ecx,0
	
	mov eax,'FTXT'
	bswap eax
	mov [esi+ecx*4],eax  	; ID	
	
	inc ecx
	mov eax,x
	mov [esi+ecx*4],eax  	; x

	inc ecx
	mov eax,y
	mov [esi+ecx*4],eax  	; y

	inc ecx
	mov eax,dwWidth
	mov [esi+ecx*4],eax  	; w
	
	inc ecx
	mov eax,dwHeigth
	mov [esi+ecx*4],eax  	; h
	
	inc ecx
	mov eax,dwColor
	mov [esi+ecx*4],eax  	; col
	
	inc ecx					; Structure of file +24
	mov eax,lpsf
	mov [esi+ecx*4],eax
	
	mov dword ptr[esi+128],0			; LineCount
	
	invoke GlobalUnlock,pntf
	invoke TakeHandleCountFrb
	dec eax
	
	
	ret
CreateTextBoxFrb endp

LoadFileTextBoxFrb proc uses esi edi dwIndex:dword,lptz:dword
	
	
	
	ret
LoadFileTextBoxFrb endp

ChangeText_TextBoxFrb proc uses esi edi ftxthnd:dword,lptxt:dword
	
	mov esi,ftxthnd
	mov eax,lptxt
	mov dword ptr[esi+28],eax
	
	
	ret
ChangeText_TextBoxFrb endp

Show_text_textbox proc uses esi edi dwInd:dword
	LOCAL pm:dword
	LOCAL vx,vy,posX,wc_t:dword
	LOCAL tmp[20]:dword
	LOCAL pw,td,ta,tc,tb:dword
	LOCAL t[100]:dword
	LOCAL lv,wv,td1:dword
	
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
	
	mov esi,eax
	lea edi,tmp
	
	
	mov eax,[esi]
	cmp eax,'TXTF'
	jz @f
		ret
	@@:

	.if KEYFRB_UP_WP=='W'
		mov ecx,[esi+28]
		cmp ecx,0
		jz @f
			mov ecx,[ecx+16]
			cmp dword ptr[esi+128],ecx
			ja @f
				inc dword ptr[esi+128]
		@@:
	.elseif KEYFRB_UP_WP=='S'
		dec dword ptr[esi+128]
		jns @f
			inc dword ptr[esi+128]
		@@:
	.endif
	
		lea edi,tmp
		xor eax,eax
	;	inc eax
		mov pw,eax
		mov [edi],eax
		inc dword ptr[edi]
		mov eax,[esi+128]
		add dword ptr[edi],eax
		
		invoke fGrad,[esi+16],15,1
		sub eax,3
		
		mov ecx,eax
		mov [edi+4],ecx
		mov eax,15
		mov [edi+8],eax
		
		
		mov edx,[esi+28]
		cmp edx,0
		jz done
		mov [edi+12],edx

	mov eax,[esi+4]
	add eax,[esi+12]
	sub eax,20
	
		mov lv,0
		invoke SetBkMode,mDCGUI,TRANSPARENT
		loop_lines:

		invoke fGrad,5,100,[esi+12]
		add eax,[esi+4]
		mov [edi+16],eax
		invoke fGrad,5,100,[esi+16]
		add eax,[esi+8]
		add eax,[edi+8]
		mov [edi+20],eax


		
		invoke TextFromFile,[edi],[edi+12]
		xor ecx,ecx
		dec ecx
		cmp eax,ecx
		jz no_word
		
		invoke UM_Word_Count,[edi+12],[edi]
		cmp eax,0
		jz no_word
			mov ecx,eax
			xor edx,edx
			mov [edi+24],edx
			inc dword ptr[edi+24]
			mov wc_t,edx
			mov pw,eax
		push [edi+16]
		
		mov wv,eax
		loop_each_word:
		push ecx
			
				invoke GetWord,[esi+28],[edi],[edi+24]
					mov eax,[edx]		; The structure
			
			push edx
			push eax
				recheck_word:
				
				
				.if eax==1
					invoke SetTextColor,mDCGUI,0ffh
				.elseif eax==-1
					invoke SetTextColor,mDCGUI,0ffffffh
				.endif
			pop	eax
			pop edx

			push eax
			push edx
				xor edx,edx
				mov eax,wc_t
				mov ecx,10
				mul ecx
				add eax,[edi+16]
				mov ecx,eax
				mov posX,eax
			pop edx
			pop eax
			
			mov eax,[edx+8]
			add wc_t,eax
			
			push eax
			push edx
				xor edx,edx
				mov eax,[esi+12]
				mov ecx,13
				div ecx
				mov ecx,eax
			pop edx
			pop eax
				cmp wc_t,35
				ja out_of_cap
				invoke TextOut,mDCGUI,posX,[edi+8],[edx+4],[edx+8]
		skip_change2:	
		pop ecx
		inc dword ptr[edi+24]
		inc wv
		dec ecx
		jnz loop_each_word
		
		out_of_cap:
		pop [edi+16]
		
		no_word:
		
			invoke UM_Word_Count,[esi+28],[edi]
			xchg eax,edx
			
			invoke dw2a,edx,addr t
			invoke TextOut,mDCGUI,530,[edi+8],addr t,eax

		add dword ptr[edi+8],15
		inc dword ptr[edi]
		inc lv
		dec dword ptr[edi+4]
		jnz loop_lines
		
		
		
	done:
	ret
Show_text_textbox endp

DrawTextBoxFrb proc dwInd:dword
	LOCAL tmp[20]:dword
	LOCAL wcnt,posx,tl,ta,tc,td,cntr_1,wc_t,posX:Dword
	LOCAL t[100]:byte
	
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
	
	mov esi,eax
	lea edi,tmp
	
	
	mov eax,[esi]
	cmp eax,'TXTF'
	jz @f
		ret
	@@:
	
;	invoke GlobalLock,esi
;	mov esi,eax
;	invoke GlobalUnlock,esi
	
	push esi
	invoke fButton,addr guis,[esi+4],[esi+8],[esi+12],[esi+16],[esi+20]
	pop esi
		
	mov ecx,[esi+28]
	cmp ecx,0
	jz @f
		pushad
			invoke IsInsideRect,m.x,m.y,eax,[esi+8],20,[esi+16]
			cmp eax,1
			jnz not_inside
				mov ecx,[esi+28]
				invoke fGrad,m.y,[esi+16],[ecx+16]
				mov [esi+128],eax
			not_inside:
		popad
			invoke fScrollBar,addr guis,eax,[esi+8],20,[esi+16],[esi+128],[ecx+16],0128
	@@:
	
		
	done:
;	invoke GlobalUnlock,esi
	
	
	ret
DrawTextBoxFrb endp


DrawButtonFrb proc uses esi edi dwInd:dword
	LOCAL tmp[20]:dword
	
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
	
	mov esi,eax
	lea edi,tmp
	
	
	; 0 = Header
	; 4 = x
	; 8 = y
	; 12 = w
	; 16 = h
	
	mov eax,[esi]
	cmp eax,'XBRF'
	jz @f
		ret
	@@:
	
	invoke GlobalLock,esi
	mov esi,eax
	
	mov [edi+24],eax
	
	mov eax,[esi+12]
	add eax,[esi+4]
	mov [edi],eax		; w + x
	
	mov eax,[esi+16]
	add eax,[esi+8]
	mov [edi+4],eax		; h + y

	mov ecx,[esi+16]
	mov [edi+16],ecx
	
	mov edx,[esi+12]	
	xor ecx,ecx
	@@:
	mov [edi+8],ecx
	mov [edi+12],edx
		invoke FrbPixelPut,addr guis,[edi],[edi+4],[esi+ecx*4+24]
	dec dword ptr[edi]
	mov ecx,[edi+8]
	mov edx,[edi+12]
	dec edx
	jnz @b

	mov edx,[esi+12]		
	mov eax,[esi+12]
	add eax,[esi+4]
	mov [edi],eax
	
	dec dword ptr[edi+4]
	inc ecx
	dec dword ptr[edi+16]	
	jnz @B
	
	mov edx,dwInd
	mov eax,m_hlgt
	cmp eax,edx
	jnz @f
		cmp eax,m_mcur
		jnz @f
		mov m_mcur,edx
		
;		invoke CreatePixel16,128,0,0,guis.nBit
;		mov [edi+28],eax
		
;		mov edx,[esi+4]
;		mov eax,[esi+8]
;		
;		inc edx
;		inc eax
;		
;		INVOKE RectMod,addr guis,edx,eax,[esi+12],[esi+16],[edi+28],0
	@@:
	
	mov eax,[edi+24]
	invoke GlobalUnlock,eax
	

	
	ret
DrawButtonFrb endp



MouseResponseFrb proc uses esi edi hWnd:dword,dwInd:dword
	LOCAL tmp[20]:dword
	
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
	
	mov esi,eax
	lea edi,tmp
	
	
	; 0 = Header
	; 4 = x
	; 8 = y
	; 12 = w
	; 16 = h
	
	
	
	invoke IsInsideRect,m.x,m.y,[esi+4],[esi+8],[esi+12],[esi+16]
	cmp eax,1
	jnz @f
		mov eax,dwInd
		cmp m_hlgt,eax
		jz @f
		mov m_hlgt,eax
;		invoke SendMessage,hWnd,WM_USER,m_hlgt,1
	@@:
	
	
	
	ret
MouseResponseFrb endp

ShowListFrb proc dwIndex:dword,x:dword,y:dword
	LOCAL t[128]:byte
	LOCAL p:dword
	
	invoke TakeHandleCountFrb
	cmp eax,0
	ja @f
		ret
	@@:
	
	mov esi,lpDataGUI
	add esi,4
	
	mov eax,y
	mov p,eax
	
	mov ecx,dwIndex
	mov eax,[esi+ecx*4]
	xchg esi,eax

	invoke dw2hex,esi,addr t
	invoke TextOut,mDCGUI,x,p,addr t,8
	
	mov eax,x
	add eax,100
	invoke TextOut,mDCGUI,eax,p,esi,4
	add p,15
		
	add esi,4
	
	mov edx,[esi]
	mov ecx,16
	@@:
	push esi
	push ecx
		invoke dw2a,edx,addr t
		mov edx,x
		add edx,100
		invoke TextOut,mDCGUI,edx,p,addr t,eax
	pop ecx
	pop esi	
	add esi,4
	mov edx,[esi]
	add p,15
	sub ecx,4
	jnz @b
	
	
	ret
ShowListFrb endp

ButtonListDrawFrb proc uses esi dwInd:dword
	LOCAL pm:dword
	
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
		
	mov esi,eax
	mov eax,[esi]
	cmp eax,'XBRF'
	jz frbx
	cmp eax,'TXTF'
	jz ftxt
	ret
	
	frbx:
	invoke DrawButtonFrb,ecx
	
	ret
	ftxt:
	invoke DrawTextBoxFrb,ecx
	
	ret
ButtonListDrawFrb endp

ButtonListTextDrawFrb proc uses esi edi dwInd:dword
	LOCAL pm:dword
	LOCAL vx,vy,posX,wc_t:dword
	LOCAL tmp[20]:dword
	LOCAL pw,td,ta,tc,tb:dword
	LOCAL t[100]:dword
	LOCAL lv,wv:dword
	
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
		
	mov esi,eax
	mov eax,[esi]
	cmp eax,'XBRF'
	jz frbx
	cmp eax,'TXTF'
	jz ftxt
	ret
	
	frbx:
	mov esi,lpDataGUI
	mov ecx,dwInd
	
	add esi,4
	mov eax,[esi+ecx*4]
	
	mov esi,eax
	
	mov eax,[esi+20]
	cmp eax,0
	jz @f
		invoke SetTextColor,mDCGUI,0ffffffh
		invoke SetBkMode,mDCGUI,TRANSPARENT
		invoke fGrad,10,100,[esi+12]
		add eax,[esi+4]
		mov vx,eax
		invoke fGrad,10,100,[esi+16]
		add eax,[esi+8]
		mov vy,eax
		
		invoke TextOut,mDCGUI,vx,vy,[esi+20],[esi+24]
	@@:
	
	ret
	
	ftxt:
	invoke Show_text_textbox,dwInd
		
	
	
	done:
	ret
ButtonListTextDrawFrb endp

DrawFrameFrb proc uses esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;	LOCAL hDC:dword,hlgt:dword
LOCAL r:RECT
	; Todo: Sub_main_Function here.
	
	.if VideoFrb==0
		
		invoke BitBlt,hDC,0,0,800,600,mDCGUI,0,0,SRCCOPY 	
	
	invoke TakeHandleCountFrb
	xor ecx,ecx
	cmp eax,ecx
	jnz @f
		ret
	@@:
	push eax
		dec eax
		invoke MouseResponseFrb,hWnd,eax
	pop eax
	dec eax
	jnz @b
	
	.elseif VideoFrb==1
		invoke GetWindowRect,hWnd,addr r
		invoke ResizeObject,r.right,r.bottom
	;	invoke glBitmap,1024,768,addr xorg,addr xorg+4,addr xorg+8,addr xorg+12,guis.lpBits
		invoke DrawScene 		
	.endif
	
		
	ret
DrawFrameFrb endp

InputMouseFrb proc lParam:dword
	
		mov eax,lParam
		mov ecx,eax
		and eax,0FFFFh
		mov m.x,eax
		
		shr ecx,16
		mov m.y,ecx	
	
	ret
InputMouseFrb endp

SetFontFrb proc hnd:dword
	
	invoke SelectObject,mDCGUI,hnd
	
	ret
SetFontFrb endp

fScrollBar proc lps:dword,x:dword,y:dword,l:dword,t:dword,index:dword,nMaxIndex:dword,col:dword
	
	
	invoke fButton,lps,x,y,l,t,col
	invoke fButton,lps,x,y,l,20,col
	mov eax,y
	add eax,t
	sub eax,20
	invoke fButton,lps,x,eax,l,20,col
	
	mov eax,index
	cmp eax,nMaxIndex
	jl @f
		ret
	@@:
	
	
	mov eax,t
	sub eax,60
	invoke fGrad,index,nMaxIndex,eax
	
	add eax,y
	add eax,20
	
	
	
	invoke fButton,lps,x,eax,l,20,col
		
	
	ret
fScrollBar endp

MessageInterceptFrb proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL r:RECT 
	LOCAL t[1024]:byte
	
	invoke GetWindowRect,hWnd,addr r
	
	.if uMsg==WM_MOUSEMOVE
		
		invoke InputMouseFrb,lParam		
		
	.elseif uMsg==WM_USER
		.if lParam==0
			mov eax,guis.lpBits
			lea eax,[eax+1024*768*4*1]
			
			push guis.lpBits
				mov guis.lpBits,eax
				push eax
					invoke CreatePixel16,0,128,0,guis.nBit
					invoke fButton,addr guis,-1,-1,1024,768,eax
			
				invoke TakeHandleCountFrb
				xor ecx,ecx
				cmp eax,ecx
				ja @f
				ret
				@@:
				push eax
					dec eax
					invoke ButtonListDrawFrb,eax
				pop eax
				dec eax
				jnz @b
			pop eax
			push eax
			invoke SetBitmapBits,hBmpGUI,1024*768*4,guis.lpBits
			invoke TakeHandleCountFrb
			xor ecx,ecx
			cmp eax,ecx
			ja @f
			ret
			@@:			
			push eax
				dec eax
				invoke ButtonListTextDrawFrb,eax
			pop eax
			dec eax
			jnz @b
			
			
			pop eax		
			invoke GetBitmapBits,hBmpGUI,1024*768*4,guis.lpBits
			pop guis.lpBits
			
			
		.elseif lParam==1
			mov eax,guis.lpBits
			lea eax,[eax+1024*768*4*1]
			
			invoke fCopyMemory,guis.lpBits,eax,1024*768*4
			invoke SetBitmapBits,hBmpGUI,1024*768*4, guis.lpBits
			invoke TakeHandleCountFrb
			xor ecx,ecx
			cmp eax,ecx
			ja @f
			ret
			@@:			
			push eax
				dec eax
				invoke ButtonListTextDrawFrb,eax
			pop eax
			dec eax
			jnz @b
			
			
		.elseif lParam==2
			
			
		.endif
		
		
	.elseif uMsg==WM_RBUTTONUP
		.if VideoFrb==0
			mov VideoFrb,1
		.else
			mov VideoFrb,0
		.endif
	.elseif uMsg==WM_LBUTTONUP
		invoke SendMessage,hWnd,WM_USER,m_hlgt,15
	;	invoke SendMessage,hWnd,WM_USER,m_hlgt,1
		
		
	.elseif uMsg==WM_SIZE
		invoke ResizeObject,r.right,r.bottom
		
		
	.elseif uMsg==WM_KEYDOWN
		mov edx,wParam
		mov eax,lParam
		
		mov KEYFRB_UP_WP,edx
		mov KEYFRB_UP_LP,eax
		.if VideoFrb==0
			invoke ControlFrb2,hWnd
		.elseif VideoFrb==1
			invoke ControlFrb,hWnd
		
		.endif
	.elseif uMsg==MM_MCINOTIFY
		invoke mciSendCommand,mo.wDeviceID,MCI_CLOSE,NULL,NULL
				
	.endif
	
	
	
	ret
MessageInterceptFrb endp

PlaySoundFrb proc
	LOCAL ThreadID:dword
			mov  edx,OFFSET Music
			invoke CreateThread,NULL,NULL,edx,\
                                       NULL,NORMAL_PRIORITY_CLASS,\
                                       ADDR ThreadID
			invoke CloseHandle,eax
	
	ret
PlaySoundFrb endp

Music proc lParam:dword
	invoke PlaySound,addr s,NULL,SND_FILENAME	
	ret
Music endp

PlaySoundFrb2 proc hWnd:dword,lptz:dword,nStart:dword,nCount:dword
	LOCAL uID,returm:dword
	LOCAL ms:MCI_SEEK_PARMS
	
	mov mo.lpstrDeviceType,offset frbsnd
	mov eax,lptz
	mov mo.lpstrElementName,eax
	invoke mciSendCommand,0,MCI_OPEN,MCI_OPEN_TYPE or MCI_OPEN_ELEMENT,addr mo
	xor ecx,ecx
	cmp eax,ecx
	jz @f
		xor eax,eax
		dec eax
		ret 
	@@:
	
	mov eax,mo.wDeviceID
	mov uID,eax
	
	mov eax,hWnd
	mov mp.dwCallback,eax
	
	mov eax,nStart
	mov mp.dwFrom,eax
	mov eax,nCount
	mov mp.dwTo,eax
	
	
	
	invoke mciSendCommand,mo.wDeviceID,MCI_PLAY,MCI_NOTIFY,addr mp
	xor ecx,ecx
	cmp eax,ecx
	jz @f
		xor eax,eax
		dec eax
		ret
	@@:
	
	
	ret
PlaySoundFrb2 endp

GlInit			PROC	ParentW:DWORD,ParentH:DWORD
			invoke	SetLightSource,GL_LIGHT0,ADDR LightSourcePosition,ADDR LightAmbient
			invoke	SetLightSource,GL_LIGHT1,ADDR LightSource2Position,ADDR Light2Ambient
			invoke	SetLightSource,GL_LIGHT2,ADDR LightSource3Position,ADDR Light3Ambient
			invoke	CreateSphere,1,GLU_LINE,GLU_SMOOTH,ADDR Sphere1Color,ADDR Sphere1Radius,sphere1Parts
			mov	GlSphere1,eax
			invoke	CreateSphere,2,GLU_FILL,GLU_SMOOTH,ADDR Sphere2Color,ADDR Sphere2Radius,sphere2Parts
			mov	GlSphere2,eax
		;	invoke CreateRect,3
			; Set global flags
			invoke	glEnable,GL_DEPTH_TEST
			invoke	glEnable,GL_LIGHTING
			invoke	glEnable,GL_CULL_FACE		; Don't render back faces
			invoke	glShadeModel,GL_SMOOTH
			invoke	glEnable,GL_NORMALIZE
			ret
GlInit			ENDP

; --------------- Display the scene
DrawScene		PROC
	    		invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
			invoke	glPushMatrix
				invoke	RotateObject,1,ADDR Sphere1Position,ADDR Sphere1AnglesSpeedFlt,ADDR Sphere1AnglesFlt
			;	invoke	glPushMatrix
					invoke	RotateObject,2,ADDR Sphere2Position,ADDR Sphere2AnglesSpeedFlt,ADDR Sphere2AnglesFlt
					invoke	glLightfv,GL_LIGHT0,GL_POSITION,ADDR LightSourcePosition		
			;	invoke	glPopMatrix
				invoke	RotateObject,3,ADDR Sphere2Position,ADDR RectAnglesSpeedFlt,ADDR Sphere2AnglesFlt
			invoke	glPopMatrix
			invoke	SwapBuffers,hDC
			ret
DrawScene		ENDP

; --------------- Resize the scene
ResizeObject		PROC	ParentW:DWORD,ParentH:DWORD
			invoke	glViewport,0,0,ParentW,ParentH
			invoke	glMatrixMode,GL_PROJECTION
			invoke	glLoadIdentity
			invoke	gluPerspective,DWORD PTR Value45Dbl,DWORD PTR Value45Dbl+4,DWORD PTR Value1Dbl,DWORD PTR Value1Dbl+4,DWORD PTR Value3Dbl,DWORD PTR Value3Dbl+4,DWORD PTR Value7Dbl,DWORD PTR Value7Dbl+4
			invoke	glMatrixMode,GL_MODELVIEW
			invoke	glLoadIdentity
			ret
ResizeObject		ENDP

; --------------- Free the memory allocated for the spheres
DeleteSpheres		PROC
			invoke	gluDeleteQuadric,GlSphere1
			ret
DeleteSpheres		ENDP

; --------------- Create a sphere with glu object
CreateSphere		PROC	ListNumber:DWORD,FillType:DWORD,NormalsType:DWORD,Color:DWORD,Radius:DWORD,Parts:DWORD
			LOCAL	GlSphere:DWORD
			invoke	glNewList,ListNumber,GL_COMPILE
			; Create a template
			invoke	gluNewQuadric
			mov	GlSphere,eax
			; Set object draw style
			invoke	gluQuadricDrawStyle,GlSphere,FillType
			; Set normals style
			invoke	gluQuadricNormals,GlSphere,NormalsType
			; Set object color
			invoke	glMaterialfv,GL_FRONT,GL_AMBIENT_AND_DIFFUSE,Color
			mov	eax,Radius
			; Create a sphere primitive
			invoke	gluSphere,GlSphere,[eax],[eax+4],Parts,Parts
			invoke	glEndList
			mov	eax,GlSphere
			ret
CreateSphere		ENDP

CreateRect proc ListNumber:dword
	LOCAL r:dword
	
	invoke	glNewList,ListNumber,GL_COMPILE
		invoke	glMaterialfv,GL_FRONT,GL_AMBIENT_AND_DIFFUSE,addr Sphere1Color
		
		
		invoke glBegin,GL_QUAD_STRIP		
		invoke glVertex3i,0,0,-1
		invoke glVertex3i,0,1,-1
		
		invoke glVertex3i,0,1,-1
		invoke glVertex3i,1,1,-1
		
		invoke glVertex3i,1,1,-1
		invoke glVertex3i,1,0,-1

		invoke glVertex3i,1,0,-1
		invoke glVertex3i,0,0,-1
		invoke glEnd

		invoke glBegin,GL_QUAD_STRIP
		invoke glVertex3i,0,0,0
		invoke glVertex3i,0,1,0
		
		invoke glVertex3i,0,1,0
		invoke glVertex3i,1,1,0
		
		invoke glVertex3i,1,1,0
		invoke glVertex3i,1,0,0

		invoke glVertex3i,1,0,0
		invoke glVertex3i,0,0,0
		invoke glEnd
		
	invoke	glEndList
	
	
	
	ret
CreateRect endp

; --------------- Set a light source
SetLightSource		PROC	LtNumber:DWORD,LtPosition:DWORD,LtAmbient:DWORD
			invoke	glLightfv,LtNumber,GL_POSITION,LtPosition
			invoke	glLightfv,LtNumber,GL_DIFFUSE,ADDR LightDiffuse
			invoke	glLightfv,LtNumber,GL_SPECULAR,ADDR LightSpecular
			invoke	glLightfv,LtNumber,GL_AMBIENT,LtAmbient
			invoke	glLightfv,LtNumber,GL_CONSTANT_ATTENUATION,ADDR LightConstAtt
			invoke	glLightfv,LtNumber,GL_LINEAR_ATTENUATION,ADDR LightLinAtt
			invoke	glLightfv,LtNumber,GL_QUADRATIC_ATTENUATION,ADDR LightQuadAtt
			invoke	glLightfv,LtNumber,GL_SPOT_CUTOFF,ADDR SpotCut
			invoke	glLightfv,LtNumber,GL_SPOT_EXPONENT,ADDR SpotExp
			invoke	glLightfv,LtNumber,GL_SPOT_DIRECTION,ADDR SpotDir
			invoke	glEnable,LtNumber
			ret	
SetLightSource		ENDP

; --------------- Position and rotate an object
RotateObject		PROC	ListNumber:DWORD,XYZPosition:DWORD,XYZRotations:DWORD,XYZAngles:DWORD
			LOCAL	LocXSpd:DWORD
			LOCAL	LocYSpd:DWORD
			LOCAL	LocZSpd:DWORD
			LOCAL	LocXAngle:DWORD
			LOCAL	LocYAngle:DWORD
			LOCAL	LocZAngle:DWORD
			mov	eax,XYZPosition
			mov	ecx,[eax]
			mov	ebx,[eax+4]
			mov	eax,[eax+8]
			invoke	glTranslatef,ecx,ebx,eax
	    		mov	eax,XYZAngles			; Rotate X
	    		mov	ebx,XYZRotations
	    		fld	DWORD PTR [eax]
	    		fadd	DWORD PTR [ebx]
	    		fstp	DWORD PTR [eax]
	    		invoke	glRotatef,[eax],Value0Flt,Value1Flt,Value0Flt
	    		mov	eax,XYZAngles			; Rotate Y
	    		mov	ebx,XYZRotations
	    		fld	DWORD PTR [eax+4]
	    		fadd	DWORD PTR [ebx+4]
	    		fstp	DWORD PTR [eax+4]
	    		invoke	glRotatef,[eax+4],Value1Flt,Value0Flt,Value0Flt
	    		mov	eax,XYZAngles			; Rotate Z
	    		mov	ebx,XYZRotations
	    		fld	DWORD PTR [eax+8]
	    		fadd	DWORD PTR [ebx+8]
	    		fstp	DWORD PTR [eax+8]
	    		invoke	glRotatef,DWORD PTR [eax+8],Value0Flt,Value0Flt,Value1Flt
			invoke	glCallList,ListNumber
			ret
RotateObject		ENDP

ControlFrb proc hWnd:dword
	LOCAL r:RECT 
	
			.if KEYFRB_UP_WP=='A'
				mov eax,10
				push eax
					fild dword ptr[esp]
					mov eax,100
					push eax
						fidiv dword ptr[esp]
					pop eax
					fld Sphere1AnglesSpeedFlt
					fsub st(0),st(1)
					fstp Sphere1AnglesSpeedFlt
				pop eax
						invoke DrawScene
			.elseif KEYFRB_UP_WP=='D'
				mov eax,10
				push eax
					fild dword ptr[esp]
					mov eax,100
					push eax
						fidiv dword ptr[esp]
					pop eax
					fld Sphere1AnglesSpeedFlt
					fadd st(0),st(1)
					fstp Sphere1AnglesSpeedFlt
				pop eax
						invoke DrawScene
			.elseif KEYFRB_UP_WP=='W'
			mov eax,10
				push eax
					fild dword ptr[esp]
					mov eax,100
					push eax
						fidiv dword ptr[esp]
					pop eax
					fld Sphere1AnglesSpeedFlt+4
					fadd st(0),st(1)
					fstp Sphere1AnglesSpeedFlt+4
				pop eax
			.elseif KEYFRB_UP_WP=='S'
			mov eax,10
				push eax
					fild dword ptr[esp]
					mov eax,100
					push eax
						fidiv dword ptr[esp]
					pop eax
					fld Sphere1AnglesSpeedFlt+4
					fsub st(0),st(1)
					fstp Sphere1AnglesSpeedFlt+4
				pop eax
			.elseif KEYFRB_UP_WP=='X'
			mov eax,500
				push eax
					fild dword ptr[esp]
					mov eax,100
					push eax
						fidiv dword ptr[esp]
					pop eax
					fld Value45Dbl
					fsub st(0),st(1)
					fstp Value45Dbl
				pop eax				
				invoke ResizeObject,r.right,r.bottom
				
			.elseif KEYFRB_UP_WP=='Z'
			mov eax,500
				push eax
					fild dword ptr[esp]
					mov eax,100
					push eax
						fidiv dword ptr[esp]
					pop eax
					fld Value45Dbl
					fadd st(0),st(1)
					fstp Value45Dbl
				pop eax				
				invoke ResizeObject,r.right,r.bottom
			.endif
	
	ret
ControlFrb endp

ControlFrb2 proc hWnd:dword
	

;	invoke ButtonListDrawFrb,m_hlgt	
	
	invoke SendMessage,hWnd,WM_USER,0,1
	
	
	ret
ControlFrb2 endp


LigthFrb proc hWnd:dword
	
	
	
	ret
LigthFrb endp